#define _GNU_SOURCE

#include <string.h>
#include <stdarg.h>
#include <stdio.h>

#include "protocol.h"

/*
 * Enqueues an error to user
 */
unsigned short protocol_enqueue_string(unsigned char *buf, const char *s, ...)
{
	unsigned short i = 0, len;
	va_list ap;
	char line[512];

	va_start(ap, s);
	vsnprintf(line, sizeof(line), s, ap);
	va_end(ap);

	buf[i++] = len = strlen(line);
	memcpy(buf + i, line, len); i += len;

	return i;
}

/*
 * Enqueues an error to user
 */
unsigned short protocol_enqueue_error(unsigned char *buf, const char *error, ...)
{
	unsigned short i = 0, len;
	va_list ap;
	char line[512];

	va_start(ap, error);
	vsnprintf(line, sizeof(line), error, ap);
	va_end(ap);

	buf[i++] = 0x01; /* signaling error */
	buf[i++] = len = strlen(line);
	memcpy(buf + i, line, len); i += len;

	return i;
}

